/*
    Aufgabe 1) Zweidimensionale Arrays und Gameplay - Mastermind
*/

import codedraw.CodeDraw;
import codedraw.Palette;
import codedraw.textformat.HorizontalAlign;
import codedraw.textformat.TextFormat;
import codedraw.textformat.VerticalAlign;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.util.Arrays;
import java.util.Random;

public class Aufgabe1 {
    // global constants
    private static final int NUMBER_OF_TURNS = 10;
    private static final int CODE_LENGTH = 4;
    private static final int NUMBER_OF_COLUMNS = CODE_LENGTH * 2 + 1;
    private static final Color[] COLORS = new Color[]{Color.BLUE, Color.CYAN, Color.GREEN, Color.MAGENTA, Color.ORANGE, Color.DARK_GRAY, Color.RED, Color.PINK, Color.YELLOW};

    // global variables
    private static int[][] playField = null;
    private static int[][] tips = null;
    private static int turn = 0;
    private static int pin = 0;
    private static int[] solution = null;

    // initializes all global variables for the game
    private static void initGame() {
        playField = new int[NUMBER_OF_TURNS][CODE_LENGTH];
        tips = new int[NUMBER_OF_TURNS][CODE_LENGTH]; // 1 == red; 2 == white
        turn = 0;
        pin = 0;
        solution = generateCode();
    }

    // generates array with length CODE_LENGTH and random numbers from 1 to COLORS.length
    private static int[] generateCode() {
        int[] newCode = new int[CODE_LENGTH];
        // TODO: Implementieren Sie hier Ihre Lösung für die Methode
        Random random = new Random();
        for (int i = 0; i < newCode.length; i++) {
            int randomInt = random.nextInt(9)+1;
            int counter = 0;
            while (counter < 10) {
                for (int j = 0; j < newCode.length; j++) {
                    if (newCode[j] != randomInt) counter++;
                    else {
                        if (randomInt == 9) randomInt = 0;
                        randomInt++;
                    }
                }
            }
            newCode[i] = randomInt;
        }
        return newCode;
    }

    // calculates red and white tip pins
    private static void updateTips() {
        for (int i = 0; i < CODE_LENGTH; i++) {
            if (solution[i] == playField[turn][i]) {
                tips[turn][0]++;
            }
            for (int j = 0; j < CODE_LENGTH; j++) {
                if (i != j && solution[i] == playField[turn][j]) {
                    tips[turn][1]++;
                }
            }
        }

        // TODO: Implementieren Sie hier Ihre Lösung für die Methode
    }

    // draws game to screen
    private static void drawGame(CodeDraw myDrawObj) {
        //Background
        myDrawObj.setColor(Color.lightGray);
        myDrawObj.fillSquare(0, 0, 800);


        for (int turnIndex = 0; turnIndex < NUMBER_OF_TURNS; turnIndex++) {
            //playfield
            for (int j = 0; j < CODE_LENGTH; j++) {
                if (playField[turnIndex][j] == 0) myDrawObj.setColor(Color.white);
                else myDrawObj.setColor(COLORS[playField[turnIndex][j] - 1]);
                myDrawObj.fillCircle(50 + j * 100, 800 - 40 - turnIndex * 80, 40);
                myDrawObj.setColor(Color.black);
                myDrawObj.drawCircle(50 + j * 100, 800 - 40 - turnIndex * 80, 40);
            }

            //redtips
            for (int j = 0; j < tips[turnIndex][0]; j++) {
                myDrawObj.setColor(Color.red);
                myDrawObj.fillCircle(5*80 + 50 + j * 80, 800 - 40 - turnIndex * 80, 20);
            }
            //whitetips
            for (int j = 0; j < tips[turnIndex][1]; j++) {
                myDrawObj.setColor(Color.white);
                myDrawObj.fillCircle(5*80 + tips[turnIndex][0]*80 + 50 + j * 80, 800 - 40 - turnIndex * 80, 20);
            }
        }

        //Buttons
        for (int i = 0; i < COLORS.length; i++) {
            myDrawObj.setColor(COLORS[i]);
            myDrawObj.fillSquare(800, i*80, 80);
        }
        myDrawObj.drawImage(800,720,"./src/back_button.png");

        myDrawObj.show();
        // TODO: Implementieren Sie hier Ihre Lösung für die Methode
    }


    private static void processGameStep(CodeDraw myDrawObj, MouseEvent me) {
        int[] clickPos = new int[2];
        clickPos[0] = me.getX();
        clickPos[1] = me.getY();

        int width = myDrawObj.getWidth();
        int height = myDrawObj.getHeight();

        if (clickPos[0] > 800) {
            // TODO: Implementieren Sie hier Ihre Lösung für die Methode
            if (clickPos[1] < 720) {
                if (pin < 4) {
                    int selectedColor = ((clickPos[1] / 80) + 1);
                    //Check if alread selected
                    boolean alreadChecked = false;
                    for (int i : playField[turn]) {
                        if (i == selectedColor) alreadChecked = true;
                    }
                    if (!alreadChecked) {
                        //Add selected to playfield
                        playField[turn][pin] = selectedColor;
                        pin++;
                    }
                }
                if (pin == 4) {
                    //Evaluate choices
                    pin = 0;

                    //Update Tips
                    updateTips();

                    //When all guessed right win
                    if (tips[turn][0] == 4) {
                        System.out.println("Won");
                        drawGame(myDrawObj);

                        myDrawObj.setColor(Color.green);
                        myDrawObj.fillRectangle(width / 2 - 220, height / 2 - 50, 440, 100);
                        myDrawObj.setColor(Color.white);
                        myDrawObj.drawText(width / 2 - 40, height / 2 - 5, "You WON!");
                        myDrawObj.show(5000);

                        clearBoard(myDrawObj);
                    }
                    else
                    {
                        turn++;
                    }
                }
            }
            else
            {
                if (pin > 0) {
                    pin--;
                    playField[turn][pin] = 0;
                }
            }

            //When lose
            if (turn >= NUMBER_OF_TURNS) {
                turn--;
                //When turn 10 lose
                System.out.println("Lost");
                drawGame(myDrawObj);

                myDrawObj.setColor(Color.red);
                myDrawObj.fillRectangle(width / 2 - 220, height / 2 - 50, 440, 100);
                myDrawObj.setColor(Color.white);
                myDrawObj.drawText(width / 2 - 40, height / 2 - 5, "You Lost!");
                myDrawObj.show(5000);

                clearBoard(myDrawObj);
            }

            drawGame(myDrawObj);
        }
    }
	
	// clears game board
    private static void clearBoard(CodeDraw myDrawObj) {
        System.out.println("Clear board");
        while (turn >= 0) {
            playField[turn] = new int[CODE_LENGTH];
            tips[turn][0] = 0;
            tips[turn][1] = 0;

            drawGame(myDrawObj);
            myDrawObj.show(500);

            turn--;
        }

        //Start new Game
        initGame();
        // TODO: Implementieren Sie hier Ihre Lösung für die Methode
    }

    public static void main(String[] args) {

        int height = 800;
        int width = height + height / (COLORS.length + 1);

        CodeDraw myDrawObj = new CodeDraw(width, height);
        myDrawObj.setTitle("MasterMind Game");

        initGame();

        //for testing to print the solution
        System.out.println(Arrays.toString(solution));

        drawGame(myDrawObj);

        myDrawObj.onMouseClick(Aufgabe1::processGameStep);
    }
}



